Package org.apache.tapestry5.services.compatibility

## Interface DeprecationWarning

- All Known Implementing Classes:
    `DeprecationWarningImpl`

      public interface DeprecationWarning

  Used to report deprecation warnings for components.
  Since:
    5.4

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `componentParameter​(ComponentResources resources, String parameterName, String message)` | Used to identify a component parameter that has been deprecated.
    `void` | `componentParameterValue​(ComponentResources resources, String parameterName, Object parameterValue, String message)` | Used to identify a specific parameter value that is no longer supported.
    `void` | `ignoredComponentParameters​(ComponentResources resources, String... parameterNames)` | The most common case: checks to see if the parameter name is bound and if so emits a warning that the parameter is ignored and will be removed.

- - ### Method Detail

    - #### componentParameter

          void componentParameter​(ComponentResources resources,
                                  String parameterName,
                                  String message)

      Used to identify a component parameter that has been deprecated. Typically, such parameters are simply ignored, but the message should be specific about this.
      Parameters:
        `resources` - identifies the component, including its location
        `parameterName` - name of the deprecated parameter
        `message` - message to display; typically explains what action will be taken, such as simply ignoring the parameter entirely. This should clarify the issue to the developer, guiding them towards resolving the deprecation, typically be eliminating the parameter entirely.

    - #### ignoredComponentParameters

          void ignoredComponentParameters​(ComponentResources resources,
                                          String... parameterNames)

      The most common case: checks to see if the parameter name is bound and if so emits a warning that the parameter is ignored and will be removed.
      Parameters:
        `resources` - identifies the component, including its location
        `parameterNames` - names of the deprecated parameters

    - #### componentParameterValue

          void componentParameterValue​(ComponentResources resources,
                                       String parameterName,
                                       Object parameterValue,
                                       String message)

      Used to identify a specific parameter value that is no longer supported. The first time this combination of component, parameter name, and parameter value are provided, an error is logged against this service's logger, including the component type and complete id, name of parameter (but not the value), the message, and the location of the component.
      Parameters:
        `resources` - identifies the component, including its location.
        `parameterName` - name of parameter containing illegal value.
        `parameterValue` - value that is not supported (typically, an enum type). May be null.
        `message` - message to display; typically explains that action will be taken, such as treating the value as an alternate value, or simply ignoring the value. This should clarify the issue to the developer, guiding them towards resolving the deprecation, by changing the value, or eliminating the use of the parameter entirely.